Ti.include("../include/common.js");
Ti.include("../beans/watchbean.js");

var platform = Ti.Platform.osname;
var tablEdit = false;
Ti.App.Properties.getBool('Key Notify User ==== ' + keyNotifyUser);
var win = Ti.UI.currentWindow;
win.backgroundColor = backColor;

var tblWatch = Ti.UI.createTableView({
	backgroundColor:'transparent',
	top:0,
	left:0,
	width:320,
	height:300
});

tblWatch.addEventListener('click', function(e) {
	var index = e.index;
	var section = e.section;

	var objWatch = e.row.watchBean;
	var objCon = e.row.objCountry;
    var watchBeanId = e.rowData.watchBean.id;

	try {

		var strJobType = "";
		var strSector = "";
		var strCountry = "";

		var strTitle="";
		var strDesc="";

		if(objWatch.location != "") {
			strCountry = '<and><eq><name>jobLocationID</name><value>' + objCon.id + '</value></eq></and>';
		}

		if(objWatch.sector != "") {
			strSector = '<and><eq><name>extraField1</name><value>' + objWatch.sector + '</value></eq></and>';
		}

		if(objWatch.jobtype != "") {
			strJobType = '<and><eq><name>jobTypeTitle</name><value>' + objWatch.jobtype + '</value></eq></and>';
		}

		strParam = strJobType + strSector + strCountry;
		if(objWatch.jobTitle != null && objWatch.jobTitle != "") {
			strTitle = '<and><or><like><name>title</name><value>%' + tf1.value + '%</value></like></or>';			
			strDesc = '<or><like><name>extraField2</name><value>%' + tf1.value + '%</value></like></or></and>';
		}

		var strUrl =  strParam + strTitle + strDesc;
		strUrl = '<filter>' + strUrl + '</filter>';
		Ti.API.info('URL >>>>>>>>>>>>>>>>>> ' + strUrl);


	} catch(e) {
		Ti.API.info(e);
	}

    if(platform == 'iphone'){
        watchJobDetail(strUrl);
    }
    else{
        var optionsDialogOpts = {
            options:['View Details', 'Delete'],
            destructive:1,
            cancel:3,
            title:'Customize your Watch'
        };


        var dialog = Titanium.UI.createOptionDialog(optionsDialogOpts);
        dialog.show();


        dialog.addEventListener('click',function(e)
        {   
    
            if(e.index == 0){
                watchJobDetail(strUrl);
            }
            else{
                deleteWatchJobs(watchBeanId);
                getWatchDogs();
            }
        });
    }
});
tblWatch.addEventListener('delete', function(e) {

	Ti.API.info("To Delete : "+e.rowData.watchBean.id);
    deleteWatchDogs(e.rowData.watchBean.id);
});

function watchJobDetail(strUrl){
    var jobResultWindow = Titanium.UI.createWindow({
		url: '../Search/jobsearch.js',
		backButtonTitle:'Back',
		navBarHidden: false,
		backgroundColor:backColor,
		title:'Jobs'
	});

	jobResultWindow.param_searchUrl = strUrl;
	jobResultWindow.param_from = "Watchdogs";

	Titanium.UI.currentTab.open(jobResultWindow, {
		animated:true
	});

}

function deleteWatchJobs(watchBeanId){
    deleteWatchDogs(watchBeanId);
    getWatchDogs();
}
var footerView = Ti.UI.createView({
	height:'1',
	backgroundColor: 'transparent'
});

tblWatch.footerView = footerView;
win.add(tblWatch);

var viewNotification = Ti.UI.createView({
	bavkgroundColor:'white',
	bottom:10,
	left:10,
	width:300,
	height:40,
	borderRadius:10,
	borderColor:'#8c8186',
	color:'black',
	font: {
		fontSize:20,
		fontWeight:'bold'
	}
});

var lblNotification = Ti.UI.createLabel({
	text:'Notification',
	left:10
});

viewNotification.add(lblNotification);

var notifyValue = Ti.App.Properties.getBool(keyNotifyUser);

if(notifyValue == null) {
	notifyValue = true;
	Ti.App.Properties.setBool(keyNotifyUser, true);
}

Ti.API.info("Notificaiton : "+notifyValue);

var swtch = Ti.UI.createSwitch({
	right: 10,
	top: (platform == 'iphone') ? 7 : 0,
	value: notifyValue
});

swtch.addEventListener('change', function(e) {
	//alert(e.value);
	Ti.App.Properties.setBool(keyNotifyUser, e.value);
	if(e.value) {
		changeNotification('enableall');
	} else {
		changeNotification('disableall');
	}

});
viewNotification.add(swtch);

win.add(viewNotification);

function parseXMLWatch(xmldata) {

	//------------ Parsing and Creating XML nodes and Objects --------------------
	//var xml = Ti.XML.parseString(xmldata);
	var doc = xmldata.documentElement;

	var elesSel = doc.getElementsByTagName("watchdog");

	var arrWatchDogs = [];
	if(elesSel != null) {
		Ti.API.info("eleSel Length:>>>"+elesSel.length);

		for (var c=0;c< elesSel.length;c++) {

			var selector = elesSel.item(c);

			var childs = selector.childNodes;

			var objWatchDog =  new WatchDog();

			for(var d=0;d<childs.length;d++) {


				if(childs.item(d).nodeName == 'id') {

					objWatchDog.id = childs.item(d).text;
					//Ti.API.info("id - " + objWatchDog.id);

				} else if(childs.item(d).nodeName == 'clientID') {

					objWatchDog.clientID = childs.item(d).text;
					//Ti.API.info('clientID - ' + objWatchDog.clientID);

				} else if(childs.item(d).nodeName == 'deviceID') {

					objWatchDog.deviceID = childs.item(d).text;
					//Ti.API.info('deviceID - ' + objWatchDog.deviceID);

				} else if(childs.item(d).nodeName == 'searchData') {

					objWatchDog.searchData = childs.item(d).text;

					if(childs.item(d).text != "") {

						var nameEle = childs.item(d).getElementsByTagName("name");
						var valEle = childs.item(d).getElementsByTagName("value");


						for(var j=0; j < nameEle.length; j++) {

							if(nameEle.item(j).text == "jobTypeTitle") {

								if(valEle.item(j).text == 'contract') {
									objWatchDog.jobtype = 'Contract';
								} else if(valEle.item(j).text == 'permanent') {
									objWatchDog.jobtype = 'Permanent';
								} else {
									objWatchDog.jobtype = 'Temporary';
								}

							} else if(nameEle.item(j).text == "extraField1") {
								objWatchDog.sector =  valEle.item(j).text;

							} else if(nameEle.item(j).text == "jobLocationID") {
								objWatchDog.location =  valEle.item(j).text;

							} else if(nameEle.item(j).text == "title") {
								var registryExp = new RegExp("%","gi");
								objWatchDog.jobTitle =  valEle.item(j).text.replace(registryExp, "");
							}

						}


					}

				} else if(childs.item(d).nodeName == 'enabled') {

					objWatchDog.enabled = childs.item(d).text;

				}

			}

			arrWatchDogs[c] = objWatchDog;

		}


		Ti.API.info("Array WatchDogs:>>>"+ arrWatchDogs.length);
	}
	setData(arrWatchDogs);
}

function getWatchDogs() {

	tblWatch.editing = false;
	btnEdit.title = 'Remove';

    
	Ti.App.fireEvent('show_indicator', {
		title: 'Loading...'
	});

	var xhr5 = Ti.Network.createHTTPClient();
	var strFilter = win.param_searchUrl;

	var hashToSend = hashCode;
	var deviceId = Ti.App.Properties.getString('deviceid');
	if(deviceId == null || deviceId == "") {
		alert("Device not registered, plz try to restart app and come back");
		return;
	}
	var xmlToSend = '<?xml version="1.0"?>'
	+'<idibu>'
	+'<request what="notify">'
	+'<action>get</action>'
	+'<deviceID>'+deviceId+'</deviceID>'
	+'</request>'
	+'</idibu>';
	Ti.API.info("XML : >>"+ xmlToSend);

	xhr5.onload = function() {
		if (this.status == 200) {
			var typesXML = this.responseXML;
			Ti.API.info('get Watches >>> ' + this.responseText);
			parseXMLWatch(typesXML);
			//alert("Wathch has been added");
			Ti.App.fireEvent('hide_indicator');

		} else {
			Ti.UI.createAlertDialog({
				title: 'Sorry!',
				message: 'There was a problem to getting Watchdogs'
			}).show();

			Ti.App.fireEvent('hide_indicator');
		}

	};
	xhr5.onerror = function(e) {
		alert('No Data Connection');
		Ti.App.fireEvent('hide_indicator');
	};
	xhr5.open("POST", serverUrl);
	xhr5.send({
		client: hashToSend,
		query: xmlToSend
	});
}

function deleteWatchDogs(idWatchDog) {

	
	Ti.App.fireEvent('show_indicator', {
		title: 'Loading...'
	});


	var xhr5 = Ti.Network.createHTTPClient();

	var hashToSend = hashCode;
	var deviceId = Ti.App.Properties.getString('deviceid');
	if(deviceId == null || deviceId == "") {
		alert("Device not registered, plz try to restart app and come back");
		return;
	}
	var xmlToSend = '<?xml version="1.0"?>'
	+'<idibu>'
	+'<request what="notify">'
	+'<action>delete</action>'
	+'<deviceID>'+deviceId+'</deviceID>'
	+'<id>'+idWatchDog+'</id>'
	+'</request>'
	+'</idibu>';
	Ti.API.info("XML : >>"+ xmlToSend);

	xhr5.onload = function() {
		if (this.status == 200) {
			var typesXML = this.responseXML;
			Ti.API.info('delete Watchdogs >>> ' + this.responseText);
			Ti.App.fireEvent('hide_indicator');

		} else {

			Ti.UI.createAlertDialog({
				title: 'Sorry!',
				message: 'There was a problem to deleting Watchdog'
			}).show();

			Ti.App.fireEvent('hide_indicator');
		}

	};
	xhr5.onerror = function(e) {
		alert('No Data Connection');
		Ti.App.fireEvent('hide_indicator');
	};
	xhr5.open("POST", serverUrl);
	xhr5.send({
		client: hashToSend,
		query: xmlToSend
	});
}

function changeNotification(flag) {

	
	Ti.App.fireEvent('show_indicator', {
		title: 'Loading...'
	});


	var xhr5 = Ti.Network.createHTTPClient();

	var hashToSend = hashCode;
	var deviceId = Ti.App.Properties.getString('deviceid');
	if(deviceId == null || deviceId == "") {
		alert("Device not registered, plz try to restart app and come back");
		return;
	}
	var xmlToSend = '<?xml version="1.0"?>'
	+'<idibu>'
	+'<request what="notify">'
	+'<action>'+flag+'</action>'
	+'<deviceID>'+deviceId+'</deviceID>'
	+'</request>'
	+'</idibu>';
	Ti.API.info("XML : >>"+ xmlToSend);

	xhr5.onload = function() {
		if (this.status == 200) {
			var typesXML = this.responseXML;
			Ti.API.info('ChangeNotification >>> ' + this.responseText);
			Ti.App.fireEvent('hide_indicator');
		} else {
			Ti.UI.createAlertDialog({
				title: 'Sorry!',
				message: 'There was a problem to change notification status.'
			}).show();

			Ti.App.fireEvent('hide_indicator');
		}

	};
	xhr5.onerror = function(e) {
		alert('No Data Connection');
		Ti.App.fireEvent('hide_indicator');
	};
	xhr5.open("POST", serverUrl);
	xhr5.send({
		client: hashToSend,
		query: xmlToSend
	});
}

var data = [];

function setData(arrForTable) {
	var data = [];

	var arrCon = Titanium.App.Properties.getList('arrCountry');
	for (var i = 0; i < arrForTable.length; i++) {

		var row = Titanium.UI.createTableViewRow({
			height: 40,
			hasChild: true
		});

		var objWatch = arrForTable[i];

		var label = Titanium.UI.createLabel({
			left: 10,
			top: 0,
			height: 40,
			color: '#8c8186',
			font: {
				fontFamily: 'Helvetica-Bold',
				fontSize: 16
			}
		});


		var objCoun;
		for(var j=0;j<arrCon.length;j++) {
			objTemp = arrCon[j];
			if(objTemp.id == objWatch.location) {
				objCoun = objTemp;
				break;
			}
		}

		var title = "";


		if(objWatch.jobTitle != null && objWatch.jobTitle != "") {
			title = objWatch.jobTitle + ", ";
		} else {
			title = 'All' + ', ';
		}
		if(objWatch.sector != "") {
			title = title + objWatch.sector + ", ";
		} else {
			title = title + 'All, ';
		}
		if(objWatch.location != "") {
			title = title + objCoun.code + ", ";
		} else {
			title = title + "All, ";
		}
		if(objWatch.jobtype != "") {
			title = title + objWatch.jobtype;
		} else {
			title = title + 'All';
		}


		label.text = title;
		row.add(label);

		row.watchBean = objWatch;
		row.objCountry = objCoun;

		data[i] = row;
	}

	tblWatch.setData(data);

}

var btnEdit = Ti.UI.createButton({
	title:'Remove'
});

btnEdit.addEventListener('click', function(e) {
	tablEdit = true;
	if(e.source.title == 'Remove') {

		btnEdit.title = 'Done';
		tblWatch.editing = true;

	} else {

		tblWatch.editing = false;
		btnEdit.title = 'Remove';
	}
});

if(platform == 'iphone') {
    win.setRightNavButton(btnEdit);
}
win.addEventListener('blur', function(e) {
	if(tblWatch.editing) {
		//tblWatch.editing = false;
		//btnEdit.title = 'Remove';
	}
});
getWatchDogs();

//alert('Watch Loaded First');
win.addEventListener('getWatches', function(e) {
	getWatchDogs();
	//alert('Watch Clicked');
});
win.addEventListener('focus', function(e) {
	//var arrWatch = Ti.App.Properties.getList('watch');

	//if(arrWatch != null && arrWatch.length > 0 ) {
	//setData(arrWatch);
	//}
	//Ti.API.info("WatchDogs Window Focus");
	//getWatchDogs();
});